SUBROUTINE mexfunction(nlhs, plhs, nrhs, prhs)
   USE matlab_mod

  INTEGER nlhs, nrhs
  INTEGER plhs(*), prhs(*)

  ! New declaration for the pointers.
  INTEGER, POINTER   :: pr_in_grenzen
  INTEGER, POINTER   :: pr_out_xy, pr_out_p, pr_out_beta, pr_out_verteilung, pr_out_temp
  INTEGER            :: mxgetstring, strlen
  CHARACTER*100      :: f_name
  
  DOUBLE PRECISION iterationen, niveaus, parallel

  status = mxGetString(prhs(1), f_name ,100)
  strlen = mxGetM(prhs(1))*mxGetN(prhs(1))

  ! Use pointer assignment
  pr_in_grenzen  => mxgetpr(prhs(2))

  parallel       =  mxgetscalar(prhs(3))
  iterationen    =  mxgetscalar(prhs(4))
  niveaus        =  mxgetscalar(prhs(5))

  plhs(1) = mxcreatefull(INT(iterationen),2*INT(parallel),0)  
  plhs(2) = mxcreatefull(INT(iterationen),INT(parallel),0)   
  plhs(3) = mxcreatefull(INT(iterationen),INT(parallel),0)   
  plhs(4) = mxcreatefull(INT(parallel),INT(niveaus),0)   
  plhs(5) = mxcreatefull(INT(niveaus),1,0)   

  ! Use pointer assignment
  pr_out_xy          => mxgetpr(plhs(1))
  pr_out_p           => mxgetpr(plhs(2))
  pr_out_beta        => mxgetpr(plhs(3))
  pr_out_verteilung  => mxgetpr(plhs(4))
  pr_out_temp        => mxgetpr(plhs(5))

  CALL metropolis_fortran(pr_out_xy, pr_out_p, pr_out_beta, pr_out_verteilung, pr_out_temp, &
       &f_name, pr_in_grenzen, parallel, iterationen, niveaus)

END SUBROUTINE mexfunction


