SUBROUTINE metropolis_fortran(xy_iter, p_iter, beta_iter, vert_beta, temp, f_name, grenzen, parallel, iterationen, niveaus)

  USE metro_mod
  USE statistik_mod
  !Variablendeklaration


  !Feldgren der Ein- und Ausgabeparameter
  INTEGER ::  beta_alt, beta_neu
  INTEGER ::  i, j, iter, u, v, p
  CHARACTER (len=30)::f_name

  !Einegabeparameter
  DOUBLE PRECISION grenzen(2,2), parallel, iterationen, niveaus

  !Ausgabe-Parameter
  DOUBLE PRECISION xy_iter(INT(iterationen),2*INT(parallel))
  DOUBLE PRECISION p_iter(INT(iterationen),INT(parallel))
  DOUBLE PRECISION beta_iter(INT(iterationen),INT(parallel))
  DOUBLE PRECISION vert_beta(INT(parallel),INT(niveaus)), temp(INT(niveaus))


  DOUBLE PRECISION  grenze_oben(2), grenze_unten(2)
  DOUBLE PRECISION  akzeptanz_ok(2,INT(niveaus)), intervalle(2), versuch(2,INT(niveaus))
  DOUBLE PRECISION  akzeptanz(2,INT(niveaus)), max_schritt(2,INT(niveaus))

  DOUBLE PRECISION  p_alt, p_neu, beta(INT(niveaus)), schritt

  DOUBLE PRECISION  zufalls_xy(2)
  DOUBLE PRECISION  zufalls_beta, zufalls_temp, zufalls_richtung, zufalls_schritt
  DOUBLE PRECISION  zufalls_metro

  DOUBLE PRECISION  p_min, zufall, xy_alt(2), xy_neu(2), verteilung(INT(niveaus))

  vert_beta=0
  max_p=-100000000
  p_min=-1


  grenze_oben(:)=grenzen(2,:)
  grenze_unten(:)=grenzen(1,:)

  intervalle=grenze_oben-grenze_unten

  !Temperaturniveaus ermitteln und dafr das tiefste Tal suchen

  DO j=1,2000
     CALL RANDOM_NUMBER(zufalls_xy)
     FORALL (u=1:2) 
        xy_alt(u)=zufalls_xy(u)*(grenze_oben(u)-grenze_unten(u))+grenze_unten(u)
     END FORALL
     p_alt=fun2d(xy_alt,f_name)
     IF (p_alt<p_min) THEN
        p_min=p_alt
     END IF
  END DO

  p_min=LOG10(ABS(p_min))

  !Temperaturniveaus besetzen
  DO i=1,INT(niveaus)
     beta(i)=10**(-1*(i-1)*p_min/(niveaus))
  END DO
  beta(INT(niveaus))=0
  beta(1)=1
  temp=beta

  DO p=1,INT(parallel)

     versuch = 0
     akzeptanz=0
     akzeptanz_ok=0
     verteilung=0
     p_min=0     

     !Startwert fr die maximale Schrittweite berechnen
     DO i=1,INT(niveaus)
        max_schritt(:,i)=(grenze_oben-grenze_unten)/100
     END DO

     !Besetzung der xy_alt Matrix mit den noch unbekannten Werten
     CALL RANDOM_NUMBER(zufalls_xy)

     !Auswahl der unbekannten Parameter mittels Zufallszahl im vorgebenen Intervall (Grenze)
     FORALL (u=1:2) 
        xy_alt(u)=zufalls_xy(u)*(grenze_oben(u)-grenze_unten(u))+grenze_unten(u)
     END FORALL


     !erste Wahrscheinlichkeit berechnen
     p_alt=fun2d(xy_alt,f_name)

     !Beginn der Iterationen (diese Zeile ist sinnlos, aber ohne ersten Aufruf von p_neu=fun2d(...)
     !funktionieren die weiteren Aufrufe nicht richtig
     p_neu=fun2d(xy_alt,f_name)
     beta_alt=niveaus

     !  Schleife ber alle Iterationen
     DO iter=1,INT(iterationen)
        CALL RANDOM_NUMBER(zufalls_beta)
        !Wahl eines neuen beta als Vorschlag fr den Random Walk in beta-Richtung
        IF (niveaus>1) THEN
           IF (beta_alt .EQ. 1) THEN
              beta_neu=2
           ELSEIF (beta_alt .EQ. niveaus)THEN
              beta_neu=niveaus-1
           ELSEIF ((beta_alt < niveaus) .AND. (beta_alt > 1))THEN
              beta_neu=beta_alt+2*INT(2*zufalls_beta)-1
           END IF
        ELSE
           beta_neu=1
        END IF

        !Random Walk in beta-Richtung
        CALL RANDOM_NUMBER(zufalls_temp)
        CALL RANDOM_NUMBER(zufalls_metro)
        CALL RANDOM_NUMBER(zufalls_richtung)
        CALL RANDOM_NUMBER(zufalls_schritt)
        CALL RANDOM_NUMBER(zufall)

        !Zufallszahl zwischen 1 und der Anzahl der unbekannten Parameter
        zufalls_richtung=1+INT(2*zufalls_richtung) 
        xy_neu=xy_alt;     
        !Auswahl einer der Richtungen

        !Random Walk in beta-Richtung
        IF (niveaus>1) THEN
           IF ((p_alt*(beta(beta_neu)-beta(beta_alt))+&
                &(verteilung(beta_neu)-verteilung(beta_alt)))>LOG(zufalls_temp)) THEN     
              beta_alt=beta_neu
           END IF

           !Anpassung der Variable Verteilung, um Gleichverteilung bez. der beta zu erreichen
           IF (verteilung(beta_alt) .EQ. 0) THEN
              verteilung(beta_alt)=verteilung(beta_alt)-1
           ELSE
              verteilung(beta_alt)=verteilung(beta_alt)-std(verteilung)
           END IF
        END IF
        !Eigentlicher Random Walk

        !Berechnung der Schritte fr alle Parallelrechnungen
        schritt=max_schritt(INT(zufalls_richtung),beta_alt)*(2*zufalls_schritt-1)
        xy_neu(INT(zufalls_richtung))=xy_neu(INT(zufalls_richtung))+schritt           

        !Wahrscheinlichkeit der neuen Konfiguration berechnen
        p_neu=fun2d(xy_neu,f_name)


        IF (beta_alt .EQ. niveaus .AND. niveaus>1) THEN
           !Wahl einer neuen zuflligen Position im Raum der unbekannten Parameter
           CALL RANDOM_NUMBER(zufalls_xy)
           FORALL (u=1:2) 
              xy_neu(u)=zufalls_xy(u)*(grenze_oben(u)-grenze_unten(u))+grenze_unten(u)
           END FORALL
           !neue Wahrscheinlichkeit der Zufallswerte berechnen
           p_neu=fun2d(xy_neu,f_name)
           xy_alt=xy_neu
           p_alt=p_neu
        ELSE                         
           IF ((beta(beta_alt)*(p_neu-p_alt))>LOG(zufalls_metro)) THEN
              !Kontrolle, ob neuer Schritt nicht aus dem Intervall fhrt

              IF (xy_neu(INT(zufalls_richtung))>grenze_oben(INT(zufalls_richtung)))THEN
                 xy_neu(INT(zufalls_richtung))=2*grenze_oben(INT(zufalls_richtung))-xy_neu(INT(zufalls_richtung))
                 p_neu=fun2d(xy_neu,f_name)
              ELSE IF (xy_neu(INT(zufalls_richtung))<grenze_unten(INT(zufalls_richtung)))THEN
                 xy_neu(INT(zufalls_richtung))=2*grenze_unten(INT(zufalls_richtung))-xy_neu(INT(zufalls_richtung))
                 p_neu=fun2d(xy_neu,f_name)
              END IF

              xy_alt=xy_neu
              p_alt=p_neu
              !Anpassen der Akzeptanzrate, getrennt fr alle Parameter und Parallelrechnungen
              akzeptanz(INT(zufalls_richtung),beta_alt) = akzeptanz(INT(zufalls_richtung),beta_alt)+1

           END IF
        END IF
        versuch(INT(zufalls_richtung),beta_alt) = versuch(INT(zufalls_richtung),beta_alt)+1

        !Mitnotieren, wie oft jedes beta vorkommt
        vert_beta(p,beta_alt)=vert_beta(p,beta_alt)+1       


        !Anpassung der maximalen Schrittweite aus der Akzeptanzrate
        IF (MOD(iter*INT(niveaus),250) .EQ. 0)  THEN        
           DO u=1,2
              DO v=1,INT(niveaus)
                 !Schrittweite wird nur mehr dann verndert, wenn nicht 0.45 < Akzeptanzrate < 0.55
                 IF (akzeptanz_ok(u,v) .EQ. 0) THEN
                    IF (akzeptanz(u,v)/versuch(u,v)<0.45) THEN
                       max_schritt(u,v)=0.5*max_schritt(u,v)
                    ELSE IF (akzeptanz(u,v)/versuch(u,v)>0.55) THEN
                       max_schritt(u,v)=MIN(max_schritt(u,v)*2,0.5*(grenze_oben(u)-grenze_unten(u)))
                    ELSE
                       akzeptanz_ok(u,v)=1
                    END IF
                 END IF
              END DO
           END DO
        END IF
        xy_iter(iter,1+(p-1)*2:2*p)=xy_alt
        p_iter(iter,p)=p_alt
        beta_iter(iter,p)=beta_alt
     END DO
  END DO


  !Aufruf aus Matlab
  ![xy, p, beta, vert]=metropolis_fortran(f_name, grenzen, parallel, iterationen, niveaus )


  !compilieren:  
  !f90 -O -o metropolis_fortran.x metro_mod.f90 statistik_mod.f90 matlab_mod.f90 metropolis_fortran.f90 
  !(Verknpfen von Metro und den Moduls


  !mex:
  !mex metropolis_fortran.f90 metro_mod.f90 statistik_mod.f90 metro_gate.f90
  ! (Verknpfen vom Gateway Programm mit Fortran Komponenten)



END SUBROUTINE metropolis_fortran




















